package org.ddf.stress.test.helper

import org.scalatest.{FlatSpec, Matchers}

/*
 * Copyright (C) 2013-2018 MNEMOTIX <http://www.mnemotix.com/> and/or its affiliates
 * and other contributors as indicated by the @author tags.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

class PreparedInputSpec extends FlatSpec with Matchers {

  behavior of "Prepared input"

  it should "test prepared input for Form_Query" in {
    println(Form_Query("pomme"))
    Form_Query("pomme") shouldEqual """{"query":"query Form_Query(\n  $first: Int\n  $after: String\n  $formQs: String\n  $filterByPlaceId: ID\n) {\n  lexicalSenses: lexicalSensesForAccurateWrittenForm(\n    formQs: $formQs\n    first: $first\n    after: $after\n    filterByPlaceId: $filterByPlaceId\n  ) {\n    edges {\n      node {\n        id\n        definition\n        ...LexicalSenseCountriesFragment\n        lexicalEntry {\n          id\n          ...LexicalEntryPartOfSpeechListFragment\n          __typename\n        }\n        lexicographicResource {\n          id\n          altLabel\n          __typename\n        }\n        __typename\n      }\n      __typename\n    }\n    pageInfo {\n      startCursor\n      endCursor\n      hasNextPage\n      __typename\n    }\n    __typename\n  }\n}\nfragment LexicalSenseCountriesFragment on LexicalSense {\n  places {\n    edges {\n      node {\n        id\n        ...CountryFragment\n        __typename\n      }\n      __typename\n    }\n    __typename\n  }\n  __typename\n}\nfragment CountryFragment on PlaceInterface {\n  id\n  name\n  color\n  ... on City {\n    countryName\n    __typename\n  }\n  ... on State {\n    countryName\n    __typename\n  }\n  __typename\n}\nfragment LexicalEntryPartOfSpeechListFragment on LexicalEntryInterface {\n  ... on WordInterface {\n    partOfSpeech {\n      id\n      prefLabel\n      __typename\n    }\n    __typename\n  }\n  ... on InflectablePOS {\n    number {\n      id\n      prefLabel\n      __typename\n    }\n    gender {\n      id\n      prefLabel\n      __typename\n    }\n    __typename\n  }\n  ... on Verb {\n    transitivity {\n      id\n      prefLabel\n      __typename\n    }\n    __typename\n  }\n  ... on MultiWordExpression {\n    multiWordType {\n      id\n      prefLabel\n      __typename\n    }\n    __typename\n  }\n  ... on Affix {\n    termElement {\n      id\n      prefLabel\n      __typename\n    }\n    __typename\n  }\n  __typename\n}\n","variables":{"first":10,"formQs":"pomme"}}""".stripMargin
  }

  it should "test prepared input for Me" in {
    println(Me_Query)
    Me_Query() shouldEqual """{"operationName":"Me","variables":{},"query":"query Me {\n  me {\n    id\n    avatar\n    nickName\n    userAccount {\n      username\n      ...UserAccountGroupsFragment\n      __typename\n    }\n    place {\n      id\n      ...PlaceFragment\n      __typename\n    }\n    __typename\n  }\n}\n\nfragment PlaceFragment on PlaceInterface {\n  id\n  __typename\n  name\n  countryCode\n  ... on City {\n    countryId\n    countryName\n    stateName\n    __typename\n  }\n  ... on State {\n    countryId\n    countryName\n    __typename\n  }\n}\n\nfragment UserAccountGroupsFragment on UserAccount {\n  isAdmin: isInGroup(userGroupId: \"user-group/AdministratorGroup\")\n  isOperator: isInGroup(userGroupId: \"user-group/OperatorGroup\")\n  isContributor: isInGroup(userGroupId: \"user-group/ContributorGroup\")\n  __typename\n}\n"}"""
  }

  it should "test prepared input for FormTopPosts_Query" in {
    println(FormTopPosts_Query("tenir"))
    FormTopPosts_Query("tenir") shouldEqual
      """{"operationName":"FormTopPosts_Query","variables":{"formQs":"tenir"},"query":"query FormTopPosts_Query($formQs: String) {\n  topPostAboutEtymology: topPostAboutEtymologyForAccurateWrittenForm(formQs: $formQs) {\n    id\n    content\n    __typename\n  }\n  topPostAboutForm: topPostAboutFormForAccurateWrittenForm(formQs: $formQs) {\n    id\n    content\n    __typename\n  }\n}\n"}""".stripMargin
  }

  it should "test prepared input for Search_Query" in {
    println(Search_Query("moula"))
    Search_Query("moula") shouldEqual """{"operationName":"Search_Query","variables":{"first":10,"qs":"moula"},"query":"query Search_Query($first: Int, $qs: String) {\n  forms(qs: $qs, first: $first) {\n    edges {\n      node {\n        id\n        writtenRep\n        __typename\n      }\n      __typename\n    }\n    __typename\n  }\n}\n"}""".stripMargin
  }

  it should "test prepared query input for FormSeeAlso_Query" in {
    FormSeeAlso_Query("moula") shouldEqual
      """{"operationName":"FormSeeAlso_Query","variables":{"formQs":"moula"},"query":"query FormSeeAlso_Query($formQs: String) {\n  associativeRelationSemanticRelations: semanticRelationsForAccurateWrittenForm(formQs: $formQs, filterOnType: associativeRelation) {\n    edges {\n      node {\n        id\n        ...SemanticRelationFormFragment\n        __typename\n      }\n      __typename\n    }\n    __typename\n  }\n  graphicRelationSemanticRelations: semanticRelationsForAccurateWrittenForm(formQs: $formQs, filterOnType: graphicRelation) {\n    edges {\n      node {\n        id\n        ...SemanticRelationFormFragment\n        __typename\n      }\n      __typename\n    }\n    __typename\n  }\n  morphologicalRelationSemanticRelations: semanticRelationsForAccurateWrittenForm(formQs: $formQs, filterOnType: morphologicalRelation) {\n    edges {\n      node {\n        id\n        ...SemanticRelationFormFragment\n        __typename\n      }\n      __typename\n    }\n    __typename\n  }\n}\n\nfragment SemanticRelationFormFragment on SemanticRelation {\n  id\n  entries {\n    edges {\n      node {\n        id\n        lexicalEntry {\n          id\n          canonicalForm {\n            id\n            writtenRep\n            __typename\n          }\n          __typename\n        }\n        __typename\n      }\n      __typename\n    }\n    __typename\n  }\n  __typename\n}\n"}""".stripMargin
  }

  it should "test prepared query input for LexicalSense_Query" in {
    LexicalSense_Query("wkt:sense/ba5f45b1247691533e50fea9ce893fee") shouldEqual
      """{"operationName":"LexicalSense_Query","variables":{"lexicalSenseId":"wkt:sense/ba5f45b1247691533e50fea9ce893fee"},"query":"query LexicalSense_Query($lexicalSenseId: ID!) {\n  lexicalSense(id: $lexicalSenseId) {\n    id\n    definition\n    validationRatingsCount\n    canUpdate\n    usageExamples {\n      edges {\n        node {\n          id\n          bibliographicalCitation\n          value\n          __typename\n        }\n        __typename\n      }\n      __typename\n    }\n    lexicalEntry {\n      id\n      canonicalForm {\n        id\n        writtenRep\n        ...FormCountriesFragment\n        __typename\n      }\n      ...LexicalEntryPartOfSpeechListFragment\n      __typename\n    }\n    lexicographicResource {\n      id\n      prefLabel\n      altLabel\n      __typename\n    }\n    ...LexicalSenseCountriesFragment\n    ...LexicalSenseTagsFragment\n    ...LexicalSenseSemanticRelationFragment\n    ...LexicalSenseTopPostAboutSenseFragment\n    ...LexicalSenseActionsFragment\n    __typename\n  }\n}\n\nfragment LexicalSenseCountriesFragment on LexicalSense {\n  places {\n    edges {\n      node {\n        id\n        ...CountryFragment\n        __typename\n      }\n      __typename\n    }\n    __typename\n  }\n  __typename\n}\n\nfragment CountryFragment on PlaceInterface {\n  id\n  name\n  color\n  ... on City {\n    countryName\n    __typename\n  }\n  ... on State {\n    countryName\n    __typename\n  }\n  __typename\n}\n\nfragment LexicalSenseTagsFragment on LexicalSense {\n  domain {\n    id\n    prefLabel\n    __typename\n  }\n  temporality {\n    id\n    prefLabel\n    __typename\n  }\n  register {\n    id\n    prefLabel\n    __typename\n  }\n  connotation {\n    id\n    prefLabel\n    __typename\n  }\n  frequency {\n    id\n    prefLabel\n    __typename\n  }\n  textualGenre {\n    id\n    prefLabel\n    __typename\n  }\n  sociolect {\n    id\n    prefLabel\n    __typename\n  }\n  grammaticalConstraint {\n    id\n    prefLabel\n    __typename\n  }\n  senseToSenseSemanticRelations: semanticRelations(filterOnSenseToSenseTypes: true) {\n    edges {\n      node {\n        id\n        semanticRelationType {\n          id\n          prefLabel\n          __typename\n        }\n        __typename\n      }\n      __typename\n    }\n    __typename\n  }\n  __typename\n}\n\nfragment LexicalEntryPartOfSpeechListFragment on LexicalEntryInterface {\n  ... on WordInterface {\n    partOfSpeech {\n      id\n      prefLabel\n      __typename\n    }\n    __typename\n  }\n  ... on InflectablePOS {\n    number {\n      id\n      prefLabel\n      __typename\n    }\n    gender {\n      id\n      prefLabel\n      __typename\n    }\n    __typename\n  }\n  ... on Verb {\n    transitivity {\n      id\n      prefLabel\n      __typename\n    }\n    __typename\n  }\n  ... on MultiWordExpression {\n    multiWordType {\n      id\n      prefLabel\n      __typename\n    }\n    __typename\n  }\n  ... on Affix {\n    termElement {\n      id\n      prefLabel\n      __typename\n    }\n    __typename\n  }\n  __typename\n}\n\nfragment FormCountriesFragment on Form {\n  places {\n    edges {\n      node {\n        id\n        ...CountryFragment\n        __typename\n      }\n      __typename\n    }\n    __typename\n  }\n  __typename\n}\n\nfragment LexicalSenseSemanticRelationFragment on LexicalSense {\n  semanticRelations(excludeSenseToSenseTypes: true) {\n    edges {\n      node {\n        id\n        semanticRelationType {\n          id\n          prefLabel\n          __typename\n        }\n        entries {\n          edges {\n            node {\n              id\n              lexicalEntry {\n                id\n                canonicalForm {\n                  id\n                  writtenRep\n                  __typename\n                }\n                __typename\n              }\n              lexicographicResource {\n                id\n                prefLabel\n                __typename\n              }\n              __typename\n            }\n            __typename\n          }\n          __typename\n        }\n        __typename\n      }\n      __typename\n    }\n    __typename\n  }\n  __typename\n}\n\nfragment LexicalSenseTopPostAboutSenseFragment on LexicalSense {\n  topPostAboutSense {\n    id\n    content\n    __typename\n  }\n  __typename\n}\n\nfragment LexicalSenseActionsFragment on LexicalSense {\n  validationRatingsCount\n  suppressionRatingsCount\n  ...LexicalSenseValidationRatingFragment\n  ...LexicalSenseReportingRatingFragment\n  ...LexicalSenseSuppressionRatingFragment\n  __typename\n}\n\nfragment LexicalSenseValidationRatingFragment on LexicalSense {\n  validationRatingsCount\n  validationRating {\n    id\n    __typename\n  }\n  __typename\n}\n\nfragment LexicalSenseReportingRatingFragment on LexicalSense {\n  reportingRatingsCount\n  reportingRating {\n    id\n    __typename\n  }\n  __typename\n}\n\nfragment LexicalSenseSuppressionRatingFragment on LexicalSense {\n  suppressionRatingsCount\n  suppressionRating {\n    id\n    __typename\n  }\n  __typename\n}\n"}""".stripMargin
  }

  it should "test registered account" in {
    RegisterUserAccount("pr.lherisson@mnemotix.com", "rypier", "passwd", "pr.lherisson@mnemotix.com", "6454071") shouldEqual
      """{"operationName":"RegisterUserAccount","variables":{"username":"pr.lherisson@mnemotix.com","nickName":"rypier","email":"pr.lherisson@mnemotix.com","password":"passwd","gcu":true,"placeId":"geonames:6454071"},"query":"mutation RegisterUserAccount($username: String!, $password: String!, $email: String!, $nickName: String!, $placeId: ID) {\n  registerUserAccount(input: {username: $username, password: $password, email: $email, nickName: $nickName, personInput: {placeInput: {id: $placeId}}}) {\n    success\n    __typename\n  }\n}\n"}"""
  }

  it should "test login" in {
    Login("pr.lherisson@mnemotix.com", "passwd") shouldEqual
      """{"operationName":"Login","variables":{"username":"pr.lherisson@mnemotix.com","password":"passwd"},"query":"mutation Login($username: String!, $password: String!) {\n  login(input: {username: $username, password: $password}) {\n    success\n    __typename\n  }\n}\n"}"""
  }

  it should "create lexical sense" in {
    CreateLexicalSense("Petro", "noun", " Rite vaudou, il regroupe les esprits de création créole provenant de Saint-Domingue. Les esprits Petro sont en principe les lwas les plus fougueux, parfois agressifs et belliqueux. Ils rassemblent Erzulie Dantor, Marinette, les Ogoun, et Kalfu (Carrefour). Leur couleur traditionnelle est le rouge.") shouldEqual
      """{"operationName":"CreateLexicalSense","variables":{"formWrittenRep":"Petro","grammaticalCategoryId":"lexinfo:noun","definition":" Rite vaudou, il regroupe les esprits de création créole provenant de Saint-Domingue. Les esprits Petro sont en principe les lwas les plus fougueux, parfois agressifs et belliqueux. Ils rassemblent Erzulie Dantor, Marinette, les Ogoun, et Kalfu (Carrefour). Leur couleur traditionnelle est le rouge.","lexicalEntryTypeName":"Word"},"query":"mutation CreateLexicalSense($definition: String!, $formWrittenRep: String!, $lexicalEntryTypeName: String!, $grammaticalCategoryId: String) {\n  createLexicalSense(input: {definition: $definition, formWrittenRep: $formWrittenRep, lexicalEntryTypeName: $lexicalEntryTypeName, grammaticalCategoryId: $grammaticalCategoryId}) {\n    createdEdge {\n      node {\n        id\n        lexicalEntry {\n          canonicalForm {\n            id\n            writtenRep\n            __typename\n          }\n          __typename\n        }\n        __typename\n      }\n      __typename\n    }\n    __typename\n  }\n}\n"}""".stripMargin
  }
}
